'use strict';
import $wider from "./index.js";
import  "@wider/utils_require";

const $moduleName = "@wider/registry/test.js";
/* jshint +W098 */
const {
    defer,
    Require,
    registry
} = $wider;
/* jshint -W098 */
const {
    describe_loaded,
    describe_published,
    register,
    merge,
    bundle,
    find
} = registry;


// ok
register($moduleName, {
    $moduleName: $moduleName
}, "registryTester");

// throw
console.log("\nextend error expected - deliberate try to load duplicate module");
try {
    register($moduleName);
} catch (err) {}

console.log("\ntesting merge");
try {
    merge($moduleName, [{
        item: {
            value: 1,
            $moduleName: "item"
        },
        item2: 2
    }], "mergedEntries");
} catch (err) {
    console.error(err);
}

console.log("\ntesting bundle - error expected for item2 as it is not a module object");
try {
    bundle([{
            value: 1,
            $moduleName: "item"
        },
        2
    ], "anotherSection");
} catch (err) {
    console.error(err);
}

// demo bundle for readMe
const something1 = {
    $moduleName: "something1"
};
const something2 = {
    $moduleName: "something2"
};
console.log("\n README bundle demo");
const sOOE = [something1, something2];
bundle(sOOE, "sOOname");

console.log("\ndemo merge for readme first fails - no matching container");

const newProps = {
    a: 1,
    b: 2,
    c: 3
};
merge(something1.$moduleName);


merge(something1.$moduleName, newProps);
console.log("\ndemo merge for readme second works");

// try a soft load
if (global.$wider)
    process.nextTick(() => {
        console.log("\n testing soft register - should throw an untrapped error as moduleName already loaded and appear after the documentation output in the source code following - the untrapped error halts the test");

        try {
            global.$wider.registry.register($moduleName);
        }
        catch (err) {
            console.log(err);
        }
    });

console.log("\ntest find()");
console.log(JSON.stringify(find("something1")));

console.log("\nwider");
console.log($wider);

console.log(describe_loaded());
console.log(describe_published());

console.log("\ntest complete - trying defer - async");
// firstly we need require
// the following self registers

console.log("\ntest defer load");

// make markdownIt work with require 
const changesMd = $wider.Require(new $wider.Module(), {
    extensionHandlersGlobal: $wider.Require.extensionHandlers() // default extension handlers include markdown
})("./CHANGES.md");

// now show it / note automatic camelisation of markdown-it to markdownIt
console.log(JSON.stringify(changesMd));
console.log("\n*****************\n");
// deliberately testing two requests for default extensionHandlers
const readmeMd = $wider.Require(new $wider.Module(), {
    extensionHandlersGlobal: $wider.Require.extensionHandlers() // default extension handlers include markdown
})("./README.md");
console.log(JSON.stringify(readmeMd));
console.log("\n*****************\n");

